using System;
using System.IO;
using System.Text;
using System.Data;
using System.Reflection;
using System.Diagnostics;
using System.Collections;
using Excel = Microsoft.Office.Interop.Excel;

namespace Utility4Net.Office
{
    #region Common Excel Enum Properties
    /// <summary>
    /// HTMLCSVTEXTEXCELXML
    /// </summary>
    enum SaveAsFileFormat
    {
        HTML,
        CSV,
        TEXT, 
        EXCEL,
        XML
    }
    /// <summary>
    /// ɫ,ԾExcelɫ
    /// </summary>
    public enum ColorIndex
    {
        ɫ = -4142,
        Զ = -4105,
        ɫ = 1,
        ɫ = 53,
         = 52,
         = 51,
         = 49,
         = 11,
         = 55,
        ɫ80 = 56,
         = 9,
        ɫ = 46, 

         = 12,
        ɫ = 10,
        ɫ = 14,
        ɫ = 5,
         = 47,
        ɫ50 = 16,
        ɫ = 3,
        ǳɫ = 45,
        ɫ = 43,
         = 50,
        ˮɫ = 42,
        ǳ = 41,
         = 13,
        ɫ40 = 48,
        ۺ = 7,
        ɫ = 44,
        ɫ = 6,
         = 4, 

         = 8,
         = 33,
        ÷ = 54,
        ɫ25 = 15,
        õ = 38,
        ɫ = 40,
        ǳ = 36,
        ǳ = 35,
        ǳ = 34,
         = 37,
         = 39,
        ɫ = 2
    }
    /// <summary>
    /// ˮƽ뷽ʽ
    /// </summary>
    public enum ExcelHAlign
    {
         = 1,
        , 
        ,
        ,
        ,
        ˶,
        о,
        ɢ
    }

    /// <summary>
    /// ֱ뷽ʽ
    /// </summary>
    public enum ExcelVAlign
    {
         = 1,
        ,
        ,
        ˶,
        ɢ
    }

    /// <summary>
    /// ߴ
    /// </summary>
    public enum BorderWeight 
    {
        ϸ = 1,
        ϸ = 2,
         = -4138,
         = 4
    }

    /// <summary>
    /// ʽ
    /// </summary>
    public enum LineStyle
    {
        ֱ = 1,
         = -4115,
        ߵ = 4,
        ߼ = 5,
         = -4118,
        ˫ = -4119,
         = -4142,
        б = 13
    }

    /// <summary>  
    /// »߷ʽ
    /// </summary>
    public enum UnderlineStyle
    {
        » = -4142,
        ˫ = -4119,
        ˫߳ȫ = 5,
         = 2,
        ߳ȫ = 4
    }

    /// <summary>
    /// Ԫ䷽ʽ
    /// </summary>
    public enum Pattern
    {
        Automatic = -4105,
        Checker = 9,
        CrissCross = 16,
        Down = -4121,
        Gray16 = 17, 
        Gray25 = -4124,
        Gray50 = -4125,
        Gray75 = -4126,
        Gray8 = 18,
        Grid = 15,
        Horizontal = -4128,
        LightDown = 13,
        LightHorizontal = 11,
        LightUp = 14,
        LightVertical = 12,
        None = -4142,
        SemiGray75 = 10,
        Solid = 1,
        Up = -4162,
        Vertical = -4166
    }
    #endregion

    /// <summary> 
    /// ˵    Excelӡģ
    ///     ʱṩExcelʽʽExcelģú
    /// </summary>
    public class ExcelHelper
    {
        #region Ա
        private string templetFile = null;
        private string outputFile = null;
        private object missing = Missing.Value;
        private DateTime beforeTime;   //Excel֮ǰʱ
        private DateTime afterTime;    //Excel֮ʱ
        Excel.Application app; 

        Excel.Workbook workBook;
        Excel.Worksheet workSheet;
        Excel.Range range;
        Excel.Range range1;
        Excel.Range range2;
        Excel.TextBox textBox;
        private int sheetCount = 1;   //WorkSheet
        private string sheetPrefixName = "ҳ";
        #endregion

        #region 
        /// <summary>
        /// WorkSheetǰ׺磺ǰ׺ΪҳôWorkSheetΪҳ-1ҳ-2...
        /// </summary> 
        public string SheetPrefixName
        {
            set { this.sheetPrefixName = value; }
        }

        /// <summary>
        /// WorkSheet
        /// </summary>
        public int WorkSheetCount
        {
            get { return workBook.Sheets.Count; }
        }

        /// <summary>
        /// Excelģļ·
        /// </summary>
        public string TempletFilePath 
        {
            set { this.templetFile = value; }
        }

        /// <summary>
        /// Excelļ·
        /// </summary>
        public string OutputFilePath
        {
            set { this.outputFile = value; }
        }
        #endregion

        #region 

        //#region ExcelHelper
        ///// <summary>
        ///// 캯һExcelΪģ壬ָ· 


        ///// </summary>
        ///// <param name="templetFilePath">Excelģļ·</param>
        ///// <param name="outputFilePath">Excelļ·</param>
        //public ExcelHelper(string templetFilePath, string outputFilePath)
        //{
        //    if (templetFilePath == null)
        //        throw new Exception("Excelģļ·Ϊգ");

        //    if (outputFilePath == null)
        //        throw new Exception("Excelļ·Ϊգ");

        //    if (!File.Exists(templetFilePath)) 


        //        throw new Exception("ָ·Excelģļڣ");

        //    this.templetFile = templetFilePath;
        //    this.outputFile = outputFilePath;

        //    //һApplicationʹɼ
        //    beforeTime = DateTime.Now;
        //    app = new Excel.ApplicationClass();
        //    app.Visible = true;
        //    afterTime = DateTime.Now;

        //    //ģļõWorkBook
        //    workBook = app.Workbooks.Open(templetFile, missing, missing, missing, missing, missing, 
        //        missing, missing, missing, missing, missing, missing, missing, Type.Missing, Type.Missing);

        //    //õWorkSheet
        //    workSheet = (Excel.Worksheet)workBook.Sheets.get_Item(1);

        //}

        ///// <summary>
        ///// 캯һеĹ
        ///// </summary>
        ///// <param name="fileName">Excelļ</param>
        //public ExcelHelper(string fileName)
        //{
        //    if (!File.Exists(fileName)) 

        //        throw new Exception("ָ·Excelļڣ");

        //    //һApplicationʹɼ
        //    beforeTime = DateTime.Now;
        //    app = new Excel.ApplicationClass();
        //    app.Visible = true;
        //    afterTime = DateTime.Now;

        //    //һWorkBook
        //    workBook = app.Workbooks.Open(fileName,
        //        Type.Missing, Type.Missing, Type.Missing, Type.Missing, 

        //        Type.Missing, Type.Missing, Type.Missing, Type.Missing,
        //        Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing);

        //    //õWorkSheet
        //    workSheet = (Excel.Worksheet)workBook.Sheets.get_Item(1);

        //}

        ///// <summary>
        ///// 캯½һ
        ///// </summary>
        //public ExcelHelper()
        //{
        //    //һApplicationʹɼ 


        //    beforeTime = DateTime.Now;
        //    app = new Excel.ApplicationClass();
        //    app.Visible = true;
        //    afterTime = DateTime.Now;

        //    //½һWorkBook
        //    workBook = app.Workbooks.Add(Type.Missing);

        //    //õWorkSheet
        //    workSheet = (Excel.Worksheet)workBook.Sheets.get_Item(1);

        //}
        //#endregion



        #region Data Export Methods 

        /// <summary>
        /// DataTableдExcelļԶҳ
        /// </summary>
        /// <param name="dt">DataTable</param>
        /// <param name="rows">ÿWorkSheetд</param>
        /// <param name="top">ʼ</param>
        /// <param name="left">ʼ</param>
        public void DataTableToExcel(DataTable dt, int rows, int top, int left)
        {
            int rowCount = dt.Rows.Count; //DataTable
            int colCount = dt.Columns.Count; //DataTable 

            sheetCount = this.GetSheetCount(rowCount, rows); //WorkSheet
            //   StringBuilder sb;

            //sheetCount-1WorkSheet
            for (int i = 1; i < sheetCount; i++)
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);
                workSheet.Copy(missing, workBook.Worksheets[i]);
            }

            for (int i = 1; i <= sheetCount; i++) 


            {
                int startRow = (i - 1) * rows; //¼ʼ
                int endRow = i * rows;   //¼

                //һWorkSheetô¼ΪԴDataTable
                if (i == sheetCount)
                    endRow = rowCount;

                //ȡҪдݵWorkSheet󣬲
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i); 
                workSheet.Name = sheetPrefixName + "-" + i.ToString();

                //dtедWorkSheet
                //    for(int j=0;j<endRow-startRow;j++)
                //    {
                //     for(int k=0;k<colCount;k++)
                //     {
                //      workSheet.Cells[top + j,left + k] = dt.Rows[startRow + j][k].ToString(); 
                //     }
                //    }

                //öάд
                int row = endRow - startRow;
                string[,] ss = new string[row, colCount];

                for (int j = 0; j < row; j++)
                {
                    for (int k = 0; k < colCount; k++)
                    { 

                        ss[j, k] = dt.Rows[startRow + j][k].ToString();
                    }
                }

                range = (Excel.Range)workSheet.Cells[top, left];
                range = range.get_Resize(row, colCount);
                range.Value2 = ss;

                #region WindwoճݣWebвͨ
                /*sb = new StringBuilder(); 


    for(int j=0;j<endRow-startRow;j++)
    {
     for(int k=0;k<colCount;k++)
     {
      sb.Append( dt.Rows[startRow + j][k].ToString() );
      sb.Append("\t");
     }

     sb.Append("\n");
    }

    System.Windows.Forms.Clipboard.SetDataObject(sb.ToString());

    range = (Excel.Range)workSheet.Cells[top,left];
    workSheet.Paste(range,false);*/
                #endregion

            }
        }


        /// <summary>
        /// DataTableдExcelļҳ 
        /// </summary>
        /// <param name="dt">DataTable</param>
        /// <param name="top">ʼ</param>
        /// <param name="left">ʼ</param>
        public void DataTableToExcel(DataTable dt, int top, int left)
        {
            int rowCount = dt.Rows.Count; //DataTable
            int colCount = dt.Columns.Count; //DataTable

            //öάд
            string[,] arr = new string[rowCount, colCount]; 

            for (int j = 0; j < rowCount; j++)
            {
                for (int k = 0; k < colCount; k++)
                {
                    arr[j, k] = dt.Rows[j][k].ToString();
                }
            }

            range = (Excel.Range)workSheet.Cells[top, left];
            range = range.get_Resize(rowCount, colCount);
            range.Value2 = arr; 

        }


        /// <summary>
        /// DataTableдExcelļԶҳָҪϲ
        /// </summary>
        /// <param name="dt">DataTable</param>
        /// <param name="rows">ÿWorkSheetд</param>
        /// <param name="top">ʼ</param>
        /// <param name="left">ʼ</param>
        /// <param name="mergeColumnIndex">DataTableҪϲͬе0ʼ</param>
        public void DataTableToExcel(DataTable dt, int rows, int top, int left, int mergeColumnIndex) 


        {
            int rowCount = dt.Rows.Count; //ԴDataTable
            int colCount = dt.Columns.Count; //ԴDataTable
            sheetCount = this.GetSheetCount(rowCount, rows); //WorkSheet
            //   StringBuilder sb;

            //sheetCount-1WorkSheet
            for (int i = 1; i < sheetCount; i++)
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);
                workSheet.Copy(missing, workBook.Worksheets[i]); 

            }

            for (int i = 1; i <= sheetCount; i++)
            {
                int startRow = (i - 1) * rows; //¼ʼ
                int endRow = i * rows;   //¼

                //һWorkSheetô¼ΪԴDataTable
                if (i == sheetCount)
                    endRow = rowCount;

                //ȡҪдݵWorkSheet󣬲 http://www.mscto.com 
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);
                workSheet.Name = sheetPrefixName + "-" + i.ToString();

                //dtедWorkSheet
                //    for(int j=0;j<endRow-startRow;j++)
                //    {
                //     for(int k=0;k<colCount;k++)
                //     {
                //      workSheet.Cells[top + j,left + k] = dt.Rows[startRow + j][k].ToString(); 

                //     }
                //    }

                //öάд
                int row = endRow - startRow;
                string[,] ss = new string[row, colCount];

                for (int j = 0; j < row; j++)
                {
                    for (int k = 0; k < colCount; k++)
                    { 

                        ss[j, k] = dt.Rows[startRow + j][k].ToString();
                    }
                }

                range = (Excel.Range)workSheet.Cells[top, left];
                range = range.get_Resize(row, colCount);
                range.Value2 = ss;

                //ϲͬ
                this.MergeRows(workSheet, left + mergeColumnIndex, top, rows); 

            }
        }


        /// <summary>
        /// άдExcelļԶҳ
        /// </summary>
        /// <param name="arr">ά</param>
        /// <param name="rows">ÿWorkSheetд</param>
        /// <param name="top"></param>
        /// <param name="left"></param>
        public void ArrayToExcel(string[,] arr, int rows, int top, int left)
        {
            int rowCount = arr.GetLength(0); //άһάȣ 


            int colCount = arr.GetLength(1); //άάȣ
            sheetCount = this.GetSheetCount(rowCount, rows); //WorkSheet

            //sheetCount-1WorkSheet
            for (int i = 1; i < sheetCount; i++)
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);
                workSheet.Copy(missing, workBook.Worksheets[i]);
            }

            //άдExcel 


            for (int i = sheetCount; i >= 1; i--)
            {
                int startRow = (i - 1) * rows; //¼ʼ
                int endRow = i * rows;   //¼

                //һWorkSheetô¼ΪԴDataTable
                if (i == sheetCount)
                    endRow = rowCount;

                //ȡҪдݵWorkSheet󣬲  
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);
                workSheet.Name = sheetPrefixName + "-" + i.ToString();

                //άедWorkSheet
                //    for(int j=0;j<endRow-startRow;j++)
                //    {
                //     for(int k=0;k<colCount;k++)
                //     {
                //      workSheet.Cells[top + j,left + k] = arr[startRow + j,k]; 

                //     }
                //    }

                //öάд
                int row = endRow - startRow;
                string[,] ss = new string[row, colCount];

                for (int j = 0; j < row; j++)
                {
                    for (int k = 0; k < colCount; k++)
                    { 


                        ss[j, k] = arr[startRow + j, k];
                    }
                }

                range = (Excel.Range)workSheet.Cells[top, left];
                range = range.get_Resize(row, colCount);
                range.Value2 = ss;
            }

        }//end ArrayToExcel


        /// <summary> 
        /// άдExcelļҳ
        /// </summary>
        /// <param name="arr">ά</param>
        /// <param name="top"></param>
        /// <param name="left"></param>
        public void ArrayToExcel(string[,] arr, int top, int left)
        {
            int rowCount = arr.GetLength(0); //άһάȣ
            int colCount = arr.GetLength(1); //άάȣ

            range = (Excel.Range)workSheet.Cells[top, left]; 
            range = range.get_Resize(rowCount, colCount);
            range.FormulaArray = arr;

        }//end ArrayToExcel

        /// <summary>
        /// άдExcelļҳ
        /// </summary>
        /// <param name="arr">ά</param>
        /// <param name="top"></param>
        /// <param name="left"></param>
        /// <param name="isFormula">ǷҪ</param>
        public void ArrayToExcel(string[,] arr, int top, int left, bool isFormula) 
        {
            int rowCount = arr.GetLength(0); //άһάȣ
            int colCount = arr.GetLength(1); //άάȣ

            range = (Excel.Range)workSheet.Cells[top, left];
            range = range.get_Resize(rowCount, colCount);

            //ע⣺ʹrange.FormulaArrayдϲĵԪ
            if (isFormula)
                range.FormulaArray = arr;
            else
                range.Value2 = arr; 

        }//end ArrayToExcel

        /// <summary>
        /// άдExcelļҳϲָеͬ
        /// </summary>
        /// <param name="arr">ά</param>
        /// <param name="top"></param>
        /// <param name="left"></param>
        /// <param name="isFormula">ǷҪ</param>
        /// <param name="mergeColumnIndex">Ҫϲе</param>
        public void ArrayToExcel(string[,] arr, int top, int left, bool isFormula, int mergeColumnIndex) 

        {
            int rowCount = arr.GetLength(0); //άһάȣ
            int colCount = arr.GetLength(1); //άάȣ

            range = (Excel.Range)workSheet.Cells[top, left];
            range = range.get_Resize(rowCount, colCount);

            //ע⣺ʹrange.FormulaArrayдϲĵԪ
            if (isFormula)
                range.FormulaArray = arr;
            else
                range.Value2 = arr;

            this.MergeRows(workSheet, mergeColumnIndex, top, rowCount);

        }//end ArrayToExcel

        /// <summary>
        /// άдExcelļҳ
        /// </summary>
        /// <param name="sheetIndex"></param>
        /// <param name="arr">ά</param>
        /// <param name="top"></param>
        /// <param name="left"></param>
        public void ArrayToExcel(int sheetIndex, string[,] arr, int top, int left)
        { 
            if (sheetIndex > this.WorkSheetCount)
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            // ı䵱ǰ
            this.workSheet = (Excel.Worksheet)this.workBook.Sheets.get_Item(sheetIndex);

            int rowCount = arr.GetLength(0); //άһάȣ
            int colCount = arr.GetLength(1); //άάȣ 


            range = (Excel.Range)workSheet.Cells[top, left];
            range = range.get_Resize(rowCount, colCount);

            range.Value2 = arr;

        }//end ArrayToExcel

        /// <summary>
        /// άдExcelļԶҳָҪϲ
        /// </summary>
        /// <param name="arr">ά</param>
        /// <param name="rows">ÿWorkSheetд</param>
        /// <param name="top"></param>
        /// <param name="left"></param>  
        /// <param name="mergeColumnIndex">Ķά൱DataTable0ʼ</param>
        public void ArrayToExcel(string[,] arr, int rows, int top, int left, int mergeColumnIndex)
        {
            int rowCount = arr.GetLength(0); //άһάȣ
            int colCount = arr.GetLength(1); //άάȣ
            sheetCount = this.GetSheetCount(rowCount, rows); //WorkSheet

            //sheetCount-1WorkSheet
            for (int i = 1; i < sheetCount; i++)
            { 
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);
                workSheet.Copy(missing, workBook.Worksheets[i]);
            }

            //άдExcel
            for (int i = sheetCount; i >= 1; i--)
            {
                int startRow = (i - 1) * rows; //¼ʼ
                int endRow = i * rows;   //¼

                //һWorkSheetô¼ΪԴDataTable  
                if (i == sheetCount)
                    endRow = rowCount;

                //ȡҪдݵWorkSheet󣬲
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);
                workSheet.Name = sheetPrefixName + "-" + i.ToString();

                //άедWorkSheet
                for (int j = 0; j < endRow - startRow; j++)
                { 

                    for (int k = 0; k < colCount; k++)
                    {
                        workSheet.Cells[top + j, left + k] = arr[startRow + j, k];
                    }
                }

                //öάд
                int row = endRow - startRow;
                string[,] ss = new string[row, colCount]; 

                for (int j = 0; j < row; j++)
                {
                    for (int k = 0; k < colCount; k++)
                    {
                        ss[j, k] = arr[startRow + j, k];
                    }
                }

                range = (Excel.Range)workSheet.Cells[top, left]; 


                range = range.get_Resize(row, colCount);
                range.Value2 = ss;

                //ϲͬ
                this.MergeRows(workSheet, left + mergeColumnIndex, top, rows);
            }

        }//end ArrayToExcel
        #endregion
 


        #region WorkSheet Methods

        /// <summary>
        /// ı䵱ǰ
        /// </summary> 
        /// <param name="sheetIndex"></param>
        public void ChangeCurrentWorkSheet(int sheetIndex)
        {
            //ָΧ򲻸ı䵱ǰ
            if (sheetIndex < 1)
                return;

            if (sheetIndex > this.WorkSheetCount)
                return;

            this.workSheet = (Excel.Worksheet)this.workBook.Sheets.get_Item(sheetIndex);
        }
        /// <summary> 

        /// ָƵĹ
        /// </summary>
        /// <param name="sheetName"></param>
        public void HiddenWorkSheet(string sheetName)
        {
            try
            {
                Excel.Worksheet sheet = null;

                for (int i = 1; i <= this.WorkSheetCount; i++)
                {
                    workSheet = (Excel.Worksheet)workBook.Sheets.get_Item(i); 



                    if (workSheet.Name == sheetName)
                        sheet = workSheet;
                }

                if (sheet != null)
                    sheet.Visible = Excel.XlSheetVisibility.xlSheetHidden;
                else
                {
                    this.KillExcelProcess(); 
                    throw new Exception("Ϊ\"" + sheetName + "\"Ĺ");
                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary>
        /// ָĹ 

        /// </summary>
        /// <param name="sheetIndex"></param>
        public void HiddenWorkSheet(int sheetIndex)
        {
            if (sheetIndex > this.WorkSheetCount)
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            try
            {
                Excel.Worksheet sheet = null;
                sheet = (Excel.Worksheet)workBook.Sheets.get_Item(sheetIndex);

                sheet.Visible = Excel.XlSheetVisibility.xlSheetHidden;
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        } 

        /// <summary>
        /// ָƵĹ濽ָĸùĸ
        /// </summary>
        /// <param name="sheetName"></param>
        /// <param name="sheetCount"></param>
        public void CopyWorkSheets(string sheetName, int sheetCount)
        {
            try
            {
                Excel.Worksheet sheet = null;
                int sheetIndex = 0; 

                for (int i = 1; i <= this.WorkSheetCount; i++)
                {
                    workSheet = (Excel.Worksheet)workBook.Sheets.get_Item(i);

                    if (workSheet.Name == sheetName)
                    {
                        sheet = workSheet;
                        sheetIndex = workSheet.Index; 


                    }
                }

                if (sheet != null)
                {
                    for (int i = sheetCount; i >= 1; i--)
                    {
                        sheet.Copy(this.missing, sheet);
                    }

                    //
                    for (int i = sheetIndex; i <= sheetIndex + sheetCount; i++)
                    {
                        workSheet = (Excel.Worksheet)workBook.Sheets.get_Item(i);
                        workSheet.Name = sheetName + "-" + Convert.ToString(i - sheetIndex + 1);
                    }
                } 
                else
                {
                    this.KillExcelProcess();
                    throw new Exception("Ϊ\"" + sheetName + "\"Ĺ");
                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e; 
            }
        }

        /// <summary>
        /// һһ棬
        /// </summary>
        /// <param name="srcSheetIndex">Դ</param>
        /// <param name="aimSheetIndex">λù¹ڸù</param>
        /// <param name="newSheetName"></param>
        public void CopyWorkSheet(int srcSheetIndex, int aimSheetIndex, string newSheetName)
        {
            if (srcSheetIndex > this.WorkSheetCount || aimSheetIndex > this.WorkSheetCount) 


            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            try
            {
                Excel.Worksheet srcSheet = (Excel.Worksheet)workBook.Sheets.get_Item(srcSheetIndex);
                Excel.Worksheet aimSheet = (Excel.Worksheet)workBook.Sheets.get_Item(aimSheetIndex);

                srcSheet.Copy(this.missing, aimSheet); 
                //
                workSheet = (Excel.Worksheet)aimSheet.Next; //ȡ¿Ĺ
                workSheet.Name = newSheetName;
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }


        /// <summary> 

        /// ɾ
        /// </summary>
        /// <param name="sheetName"></param>
        public void DeleteWorkSheet(string sheetName)
        {
            try
            {
                Excel.Worksheet sheet = null;

                //ҵλsheetNameĹ
                for (int i = 1; i <= this.WorkSheetCount; i++)
                { 
                    workSheet = (Excel.Worksheet)workBook.Sheets.get_Item(i);

                    if (workSheet.Name == sheetName)
                    {
                        sheet = workSheet;
                    }
                }

                if (sheet != null)
                { 


                    sheet.Delete();
                }
                else
                {
                    this.KillExcelProcess();
                    throw new Exception("Ϊ\"" + sheetName + "\"Ĺ");
                }
            }
            catch (Exception e) 

            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="sheetIndex"></param>
        public void DeleteWorkSheet(int sheetIndex)
        {
            if (sheetIndex > this.WorkSheetCount)
            { 
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            try
            {
                Excel.Worksheet sheet = null;
                sheet = (Excel.Worksheet)workBook.Sheets.get_Item(sheetIndex);

                sheet.Delete();
            }
            catch (Exception e) 

            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary>
        /// IndexõWorkSheet
        /// </summary>
        /// <param name="index"></param>       
        public Excel.Worksheet GetSheet(int index)
        {
            try
            { 
                Excel.Worksheet aimSheet = (Excel.Worksheet)workBook.Sheets.get_Item(index);
                return aimSheet;
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }
        #endregion

        #region TextBox Methods
        /// <summary> 

        /// ָıдݣÿWorkSheet
        /// </summary>
        /// <param name="textboxName">ı</param>
        /// <param name="text">Ҫдı</param>
        public void SetTextBox(string textboxName, string text)
        {
            for (int i = 1; i <= this.WorkSheetCount; i++)
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);


                try
                { 
                    textBox = (Excel.TextBox)workSheet.TextBoxes(textboxName);
                    textBox.Text = text;
                }
                catch
                {
                    this.KillExcelProcess();
                    throw new Exception("IDΪ\"" + textboxName + "\"ı");
                } 
            }
        }

        /// <summary>
        /// ָıдݣָWorkSheet
        /// </summary>
        /// <param name="sheetIndex"></param>
        /// <param name="textboxName">ı</param>
        /// <param name="text">Ҫдı</param>
        public void SetTextBox(int sheetIndex, string textboxName, string text)
        {
            workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(sheetIndex); 


            try
            {
                textBox = (Excel.TextBox)workSheet.TextBoxes(textboxName);
                textBox.Text = text;
            }
            catch
            {
                this.KillExcelProcess();
                throw new Exception("IDΪ\"" + textboxName + "\"ı");
            } 
        }

        /// <summary>
        /// ıдݣÿWorkSheet
        /// </summary>
        /// <param name="ht">HashtableļֵԱıID</param>
        public void SetTextBoxes(Hashtable ht)
        {
            if (ht.Count == 0) return;

            for (int i = 1; i <= this.WorkSheetCount; i++)
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);

                foreach (DictionaryEntry dic in ht) 


                {
                    try
                    {
                        textBox = (Excel.TextBox)workSheet.TextBoxes(dic.Key);
                        textBox.Text = dic.Value.ToString();
                    }
                    catch
                    { 
                        this.KillExcelProcess();
                        throw new Exception("IDΪ\"" + dic.Key.ToString() + "\"ı");
                    }
                }
            }
        }

        /// <summary>
        /// ıдݣָWorkSheet
        /// </summary>
        /// <param name="ht">HashtableļֵԱıID</param> 
        public void SetTextBoxes(int sheetIndex, Hashtable ht)
        {
            if (ht.Count == 0) return;

            if (sheetIndex > this.WorkSheetCount)
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(sheetIndex);

            foreach (DictionaryEntry dic in ht) 
            {
                try
                {
                    textBox = (Excel.TextBox)workSheet.TextBoxes(dic.Key);
                    textBox.Text = dic.Value.ToString();
                }
                catch
                {
                    this.KillExcelProcess();  
                    throw new Exception("IDΪ\"" + dic.Key.ToString() + "\"ı");
                }
            }
        }
        #endregion
 

      #region Cell Methods
        /// <summary>
        /// ԪдݣԵǰWorkSheet
        /// </summary>
        /// <param name="rowIndex"></param>
        /// <param name="columnIndex"></param> 


        /// <param name="text">Ҫдıֵ</param>
        public void SetCells(int rowIndex, int columnIndex, string text)
        {
            try
            {
                workSheet.Cells[rowIndex, columnIndex] = text;
            }
            catch
            {
                this.KillExcelProcess();
                throw new Exception("Ԫ[" + rowIndex + "," + columnIndex + "]дݳ");
            }
        }

        /// <summary>
        /// ԪдݣָWorkSheet
        /// </summary>
        /// <param name="sheetIndex"></param>
        /// <param name="rowIndex"></param>
        /// <param name="columnIndex"></param>
        /// <param name="text">Ҫдıֵ</param>
        public void SetCells(int sheetIndex, int rowIndex, int columnIndex, string text)
        {
            try 
            {
                this.ChangeCurrentWorkSheet(sheetIndex); //ı䵱ǰΪָ
                workSheet.Cells[rowIndex, columnIndex] = text;
            }
            catch
            {
                this.KillExcelProcess();
                throw new Exception("Ԫ[" + rowIndex + "," + columnIndex + "]дݳ");
            }
        } 

        /// <summary>
        /// ԪдݣÿWorkSheet
        /// </summary>
        /// <param name="ht">HashtableļֵԱ浥Ԫλá,</param>
        public void SetCells(Hashtable ht)
        {
            int rowIndex;
            int columnIndex;
            string position;

            if (ht.Count == 0) return;

            for (int i = 1; i <= this.WorkSheetCount; i++) 
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);

                foreach (DictionaryEntry dic in ht)
                {
                    try
                    {
                        position = dic.Key.ToString();
                        rowIndex = Convert.ToInt32(position.Split(',')[0]); 

                        columnIndex = Convert.ToInt32(position.Split(',')[1]);

                        workSheet.Cells[rowIndex, columnIndex] = dic.Value;
                    }
                    catch
                    {
                        this.KillExcelProcess();
                        throw new Exception("Ԫ[" + dic.Key + "]дݳ"); 

                    }
                }
            }
        }

        /// <summary>
        /// ԪдݣָWorkSheet
        /// </summary>
        /// <param name="ht">HashtableļֵԱ浥Ԫλá,</param>
        public void SetCells(int sheetIndex, Hashtable ht)
        {
            int rowIndex;
            int columnIndex;  
            string position;

            if (sheetIndex > this.WorkSheetCount)
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            if (ht.Count == 0) return;

            workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(sheetIndex);

            foreach (DictionaryEntry dic in ht) 
            {
                try
                {
                    position = dic.Key.ToString();
                    rowIndex = Convert.ToInt32(position.Split(',')[0]);
                    columnIndex = Convert.ToInt32(position.Split(',')[1]);

                    workSheet.Cells[rowIndex, columnIndex] = dic.Value;
                } 

                catch
                {
                    this.KillExcelProcess();
                    throw new Exception("Ԫ[" + dic.Key + "]дݳ");
                }
            }
        }

        /// <summary>
        /// õԪΪɼ
        /// </summary>
        /// <remarks> 


        /// ExcelĵԪʽΪ֣ڻʱҪЩԪFormulaR1C1ԣ
        /// дЩԪݽᰴԤ趨ĸʽʾ
        /// </remarks>
        /// <param name="arr">浥Ԫλá,</param>
        public void SetCells(int sheetIndex, string[] arr)
        {
            int rowIndex;
            int columnIndex;
            string position;

            if (sheetIndex > this.WorkSheetCount)
            { 

                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            if (arr.Length == 0) return;

            workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(sheetIndex);

            for (int i = 0; i < arr.Length; i++)
            {
                try
                {
                    position = arr[i]; 

                    rowIndex = Convert.ToInt32(position.Split(',')[0]);
                    columnIndex = Convert.ToInt32(position.Split(',')[1]);

                    Excel.Range cell = (Excel.Range)workSheet.Cells[rowIndex, columnIndex];
                    cell.FormulaR1C1 = cell.Text;
                }
                catch
                {
                    this.KillExcelProcess(); 
                    throw new Exception(string.Format("㵥Ԫ{0}", arr[i]));
                }
            }
        }

        /// <summary>
        /// ԪдݣָWorkSheet
        /// </summary>
        /// <param name="ht">HashtableļֵԱ浥Ԫλá,</param>
        public void SetCells(string sheetName, Hashtable ht)
        {
            int rowIndex; 


            int columnIndex;
            string position;
            Excel.Worksheet sheet = null;
            int sheetIndex = 0;

            if (ht.Count == 0) return;

            try
            {
                for (int i = 1; i <= this.WorkSheetCount; i++)
                {
                    workSheet = (Excel.Worksheet)workBook.Sheets.get_Item(i); 

                    if (workSheet.Name == sheetName)
                    {
                        sheet = workSheet;
                        sheetIndex = workSheet.Index;
                    }
                }

                if (sheet != null)
                { 
                    foreach (DictionaryEntry dic in ht)
                    {
                        try
                        {
                            position = dic.Key.ToString();
                            rowIndex = Convert.ToInt32(position.Split(',')[0]);
                            columnIndex = Convert.ToInt32(position.Split(',')[1]); 



                            sheet.Cells[rowIndex, columnIndex] = dic.Value;
                        }
                        catch
                        {
                            this.KillExcelProcess();
                            throw new Exception("Ԫ[" + dic.Key + "]дݳ"); 
                        }
                    }
                }
                else
                {
                    this.KillExcelProcess();
                    throw new Exception("Ϊ\"" + sheetName + "\"Ĺ");
                }
            } 

            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }


        /// <summary>
        /// ϲԪ񣬲ֵÿWorkSheet
        /// </summary>
        /// <param name="beginRowIndex">ʼ</param>
        /// <param name="beginColumnIndex">ʼ</param>
        /// <param name="endRowIndex"></param> 
        /// <param name="endColumnIndex"></param>
        /// <param name="text">ϲRangeֵ</param>
        public void MergeCells(int beginRowIndex, int beginColumnIndex, int endRowIndex, int endColumnIndex, string text)
        {
            for (int i = 1; i <= this.WorkSheetCount; i++)
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);
                range = workSheet.get_Range(workSheet.Cells[beginRowIndex, beginColumnIndex], workSheet.Cells[endRowIndex, endColumnIndex]); 


                range.ClearContents(); //ȰRangeϲŲ
                range.MergeCells = true;
                range.Value2 = text;
                range.HorizontalAlignment = Excel.XlHAlign.xlHAlignCenter;
                range.VerticalAlignment = Excel.XlVAlign.xlVAlignCenter;
            }
        }

        /// <summary>
        /// ϲԪ񣬲ֵָWorkSheet
        /// </summary> 
        /// <param name="sheetIndex">WorkSheet</param>
        /// <param name="beginRowIndex">ʼ</param>
        /// <param name="beginColumnIndex">ʼ</param>
        /// <param name="endRowIndex"></param>
        /// <param name="endColumnIndex"></param>
        /// <param name="text">ϲRangeֵ</param>
        public void MergeCells(int sheetIndex, int beginRowIndex, int beginColumnIndex, int endRowIndex, int endColumnIndex, string text)
        {
            if (sheetIndex > this.WorkSheetCount)  
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(sheetIndex);
            range = workSheet.get_Range(workSheet.Cells[beginRowIndex, beginColumnIndex], workSheet.Cells[endRowIndex, endColumnIndex]);

            range.ClearContents(); //ȰRangeϲŲ
            range.MergeCells = true; 

            range.Value2 = text;
            range.HorizontalAlignment = Excel.XlHAlign.xlHAlignCenter;
            range.VerticalAlignment = Excel.XlVAlign.xlVAlignCenter;
        }
        #endregion

       #region Row Methods
        /// <summary>
        /// ָеͬкϲÿWorkSheet
        /// </summary>
        /// <param name="columnIndex"></param>
        /// <param name="beginRowIndex">ʼ</param>
        /// <param name="endRowIndex"></param> 

        public void MergeRows(int columnIndex, int beginRowIndex, int endRowIndex)
        {
            if (endRowIndex - beginRowIndex < 1)
                return;

            for (int i = 1; i <= this.WorkSheetCount; i++)
            {
                int beginIndex = beginRowIndex;
                int count = 0;
                string text1;
                string text2; 
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(i);

                for (int j = beginRowIndex; j <= endRowIndex; j++)
                {
                    range = (Excel.Range)workSheet.Cells[j, columnIndex];
                    text1 = range.Text.ToString();

                    range = (Excel.Range)workSheet.Cells[j + 1, columnIndex];
                    text2 = range.Text.ToString(); 


                    if (text1 == text2)
                    {
                        ++count;
                    }
                    else
                    {
                        if (count > 0)
                        {  
                            this.MergeCells(workSheet, beginIndex, columnIndex, beginIndex + count, columnIndex, text1);
                        }

                        beginIndex = j + 1; //ÿʼϲ
                        count = 0; //0
                    }

                }

            } 
        }


        /// <summary>
        /// ָеͬкϲָWorkSheet
        /// </summary>
        /// <param name="sheetIndex">WorkSheet</param>
        /// <param name="columnIndex"></param>
        /// <param name="beginRowIndex">ʼ</param>
        /// <param name="endRowIndex"></param>
        public void MergeRows(int sheetIndex, int columnIndex, int beginRowIndex, int endRowIndex)
        {
            if (sheetIndex > this.WorkSheetCount) 
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            if (endRowIndex - beginRowIndex < 1)
                return;

            int beginIndex = beginRowIndex;
            int count = 0;
            string text1;
            string text2; 
            workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(sheetIndex);

            for (int j = beginRowIndex; j <= endRowIndex; j++)
            {
                range = (Excel.Range)workSheet.Cells[j, columnIndex];
                text1 = range.Text.ToString();

                range = (Excel.Range)workSheet.Cells[j + 1, columnIndex];
                text2 = range.Text.ToString();

                if (text1 == text2) 
                {
                    ++count;
                }
                else
                {
                    if (count > 0)
                    {
                        this.MergeCells(workSheet, beginIndex, columnIndex, beginIndex + count, columnIndex, text1);
                    } 



                    beginIndex = j + 1; //ÿʼϲ
                    count = 0; //0
                }

            }

        }


        /// <summary>
        /// УָָУ
        /// </summary>
        /// <param name="rowIndex"></param>
        /// <param name="count"></param>
        public void InsertRows(int rowIndex, int count) 
        {
            try
            {
                for (int n = 1; n <= this.WorkSheetCount; n++)
                {
                    workSheet = (Excel.Worksheet)workBook.Worksheets[n];
                    range = (Excel.Range)workSheet.Rows[rowIndex, this.missing];

                    for (int i = 0; i < count; i++)
                    { 
                        range.Insert(Excel.XlDirection.xlDown, missing);
                    }
                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary> 


        /// УָWorkSheetָָУ
        /// </summary>
        /// <param name="sheetIndex"></param>
        /// <param name="rowIndex"></param>
        /// <param name="count"></param>
        public void InsertRows(int sheetIndex, int rowIndex, int count)
        {
            if (sheetIndex > this.WorkSheetCount)
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet"); 

            }

            try
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets[sheetIndex];
                range = (Excel.Range)workSheet.Rows[rowIndex, this.missing];

                for (int i = 0; i < count; i++)
                {
                    range.Insert(Excel.XlDirection.xlDown, missing);
                } 

            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary>
        /// Уָ渴ָУ
        /// </summary>
        /// <param name="rowIndex"></param>
        /// <param name="count"></param> 

        public void CopyRows(int rowIndex, int count)
        {
            try
            {
                for (int n = 1; n <= this.WorkSheetCount; n++)
                {
                    workSheet = (Excel.Worksheet)workBook.Worksheets[n];
                    range1 = (Excel.Range)workSheet.Rows[rowIndex, this.missing];

                    for (int i = 1; i <= count; i++) 


                    {
                        range2 = (Excel.Range)workSheet.Rows[rowIndex + i, this.missing];
                        range1.Copy(range2);
                    }
                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess(); 


                throw e;
            }
        }

        /// <summary>
        /// УָWorkSheetָ渴ָУ
        /// </summary>
        /// <param name="sheetIndex"></param>
        /// <param name="rowIndex"></param>
        /// <param name="count"></param>
        public void CopyRows(int sheetIndex, int rowIndex, int count)
        {
            if (sheetIndex > this.WorkSheetCount) 
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            try
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets[sheetIndex];
                range1 = (Excel.Range)workSheet.Rows[rowIndex, this.missing];

                for (int i = 1; i <= count; i++) 


                {
                    range2 = (Excel.Range)workSheet.Rows[rowIndex + i, this.missing];
                    range1.Copy(range2);
                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            } 
        }

        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="rowIndex"></param>
        /// <param name="count"></param>
        public void DeleteRows(int rowIndex, int count)
        {
            try
            {
                for (int n = 1; n <= this.WorkSheetCount; n++)
                {
                    workSheet = (Excel.Worksheet)workBook.Worksheets[n]; 
                    range = (Excel.Range)workSheet.Rows[rowIndex, this.missing];

                    for (int i = 0; i < count; i++)
                    {
                        range.Delete(Excel.XlDirection.xlDown);
                    }
                }
            }
            catch (Exception e) 


            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="sheetIndex"></param>
        /// <param name="rowIndex"></param>
        /// <param name="count"></param>
        public void DeleteRows(int sheetIndex, int rowIndex, int count) 


        {
            if (sheetIndex > this.WorkSheetCount)
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            try
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets[sheetIndex];
                range = (Excel.Range)workSheet.Rows[rowIndex, this.missing]; 


                for (int i = 0; i < count; i++)
                {
                    range.Delete(Excel.XlDirection.xlDown);
                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            } 


        }

        #endregion

        #region Column Methods

        /// <summary>
        /// Уָұָ߲У
        /// </summary>
        /// <param name="columnIndex"></param>
        /// <param name="count"></param>
        public void InsertColumns(int columnIndex, int count)
        {
            try
            {
                for (int n = 1; n <= this.WorkSheetCount; n++) 


                {
                    workSheet = (Excel.Worksheet)workBook.Worksheets[n];
                    range = (Excel.Range)workSheet.Columns[this.missing, columnIndex];

                    for (int i = 0; i < count; i++)
                    {
                        range.Insert(Excel.XlDirection.xlDown, missing);
                    } 


                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary>
        /// УָWorkSheetָұָ߲У
        /// </summary>
        /// <param name="sheetIndex"></param> 
        /// <param name="columnIndex"></param>
        /// <param name="count"></param>
        public void InsertColumns(int sheetIndex, int columnIndex, int count)
        {
            if (sheetIndex > this.WorkSheetCount)
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            try 


            {
                workSheet = (Excel.Worksheet)workBook.Worksheets[sheetIndex];
                range = (Excel.Range)workSheet.Columns[this.missing, columnIndex];

                for (int i = 0; i < count; i++)
                {
                    range.Insert(Excel.XlDirection.xlDown, missing);
                }
            }
            catch (Exception e) 


            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary>
        /// Уָұ߸ָУ
        /// </summary>
        /// <param name="columnIndex"></param>
        /// <param name="count"></param>
        public void CopyColumns(int columnIndex, int count)
        {
            try 
            {
                for (int n = 1; n <= this.WorkSheetCount; n++)
                {
                    workSheet = (Excel.Worksheet)workBook.Worksheets[n];
                    //     range1 = (Excel.Range)workSheet.Columns[columnIndex,this.missing];
                    range1 = (Excel.Range)workSheet.get_Range(this.IntToLetter(columnIndex) + "1", this.IntToLetter(columnIndex) + "10000");

                    for (int i = 1; i <= count; i++) 

                    {
                        //      range2 = (Excel.Range)workSheet.Columns[this.missing,columnIndex + i];
                        range2 = (Excel.Range)workSheet.get_Range(this.IntToLetter(columnIndex + i) + "1", this.IntToLetter(columnIndex + i) + "10000");
                        range1.Copy(range2);
                    }
                } 

            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary>
        /// УָWorkSheetָұ߸ָУ
        /// </summary>
        /// <param name="sheetIndex"></param>
        /// <param name="columnIndex"></param> 
        /// <param name="count"></param>
        public void CopyColumns(int sheetIndex, int columnIndex, int count)
        {
            if (sheetIndex > this.WorkSheetCount)
            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            try
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets[sheetIndex]; 
                //    range1 = (Excel.Range)workSheet.Columns[Type.Missing,columnIndex];
                range1 = (Excel.Range)workSheet.get_Range(this.IntToLetter(columnIndex) + "1", this.IntToLetter(columnIndex) + "10000");

                for (int i = 1; i <= count; i++)
                {
                    //     range2 = (Excel.Range)workSheet.Columns[Type.Missing,columnIndex + i];
                    range2 = (Excel.Range)workSheet.get_Range(this.IntToLetter(columnIndex + i) + "1", this.IntToLetter(columnIndex + i) + "10000"); 
                    range1.Copy(range2);
                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary>
        /// ɾ
        /// </summary> 
        /// <param name="columnIndex"></param>
        /// <param name="count"></param>
        public void DeleteColumns(int columnIndex, int count)
        {
            try
            {
                for (int n = 1; n <= this.WorkSheetCount; n++)
                {
                    workSheet = (Excel.Worksheet)workBook.Worksheets[n];
                    range = (Excel.Range)workSheet.Columns[this.missing, columnIndex];  

                    for (int i = 0; i < count; i++)
                    {
                        range.Delete(Excel.XlDirection.xlDown);
                    }
                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess(); 

                throw e;
            }
        }

        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="sheetIndex"></param>
        /// <param name="columnIndex"></param>
        /// <param name="count"></param>
        public void DeleteColumns(int sheetIndex, int columnIndex, int count)
        {
            if (sheetIndex > this.WorkSheetCount) 

            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            try
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets[sheetIndex];
                range = (Excel.Range)workSheet.Columns[this.missing, columnIndex];

                for (int i = 0; i < count; i++) 


                {
                    range.Delete(Excel.XlDirection.xlDown);
                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }

        #endregion


        #region Range Methods 

        /// <summary>
        /// ָΧ򿽱Ŀ
        /// </summary>
        /// <param name="sheetIndex">WorkSheet</param>
        /// <param name="startCell">ҪĿʼCellλã磺A10</param>
        /// <param name="endCell">ҪĽCellλã磺F20</param>
        /// <param name="targetCell">ĿĿʼCellλã磺H10</param>
        public void RangeCopy(int sheetIndex, string startCell, string endCell, string targetCell)
        {
            if (sheetIndex > this.WorkSheetCount) 


            {
                this.KillExcelProcess();
                throw new Exception("ΧWorkSheetܴWorkSheet");
            }

            try
            {
                workSheet = (Excel.Worksheet)workBook.Worksheets.get_Item(sheetIndex);
                range1 = workSheet.get_Range(startCell, endCell);
                range2 = workSheet.get_Range(targetCell, this.missing); 


                range1.Copy(range2);
            }
            catch (Exception e)
            {
                this.KillExcelProcess();
                throw e;
            }
        }

        /// <summary>
        /// ָΧ򿽱Ŀ
        /// </summary>
        /// <param name="sheetName">WorkSheet</param> 
        /// <param name="startCell">ҪĿʼCellλã磺A10</param>
        /// <param name="endCell">ҪĽCellλã磺F20</param>
        /// <param name="targetCell">ĿĿʼCellλã磺H10</param>
        public void RangeCopy(string sheetName, string startCell, string endCell, string targetCell)
        {
            try
            {
                Excel.Worksheet sheet = null;

                for (int i = 1; i <= this.WorkSheetCount; i++) 

                {
                    workSheet = (Excel.Worksheet)workBook.Sheets.get_Item(i);

                    if (workSheet.Name == sheetName)
                    {
                        sheet = workSheet;
                    }
                }

                if (sheet != null) 


                {
                    for (int i = sheetCount; i >= 1; i--)
                    {
                        range1 = sheet.get_Range(startCell, endCell);
                        range2 = sheet.get_Range(targetCell, this.missing);

                        range1.Copy(range2);
                    } 
                }
                else
                {
                    this.KillExcelProcess();
                    throw new Exception("Ϊ\"" + sheetName + "\"Ĺ");
                }
            }
            catch (Exception e)
            {
                this.KillExcelProcess();  
                throw e;
            }
        }

        /// <summary>
        /// Զ
        /// </summary>
        public void RangAutoFill()
        {
            Excel.Range rng = workSheet.get_Range("B4", Type.Missing);
            rng.Value2 = "һ ";
            rng.AutoFill(workSheet.get_Range("B4", "B9"),
                Excel.XlAutoFillType.xlFillWeekdays); 

            rng = workSheet.get_Range("C4", Type.Missing);
            rng.Value2 = "һ";
            rng.AutoFill(workSheet.get_Range("C4", "C9"),
                Excel.XlAutoFillType.xlFillMonths);

            rng = workSheet.get_Range("D4", Type.Missing);
            rng.Value2 = "1";
            rng.AutoFill(workSheet.get_Range("D4", "D9"),
                Excel.XlAutoFillType.xlFillSeries);

            rng = workSheet.get_Range("E4", Type.Missing); 

            rng.Value2 = "3";
            rng = workSheet.get_Range("E5", Type.Missing);
            rng.Value2 = "6";
            rng = workSheet.get_Range("E4", "E5");
            rng.AutoFill(workSheet.get_Range("E4", "E9"),
                Excel.XlAutoFillType.xlFillSeries);

        }

        /// <summary>
        /// Ӧʽ
        /// </summary>
        public void ApplyStyle() 
        {
            object missingValue = Type.Missing;
            Excel.Range rng = workSheet.get_Range("B3", "L23");
            Excel.Style style;

            try
            {
                style = workBook.Styles["NewStyle"];
            }
            // Style doesn't exist yet.
            catch
            {
                style = workBook.Styles.Add("NewStyle", missingValue); 
                style.Font.Name = "Verdana";
                style.Font.Size = 12;
                style.Font.Color = 255;
                style.Interior.Color = (200 << 16) | (200 << 8) | 200;
                style.Interior.Pattern = Excel.XlPattern.xlPatternSolid;
            }

            rng.Value2 = "'Style Test";
            rng.Style = "NewStyle";
            rng.Columns.AutoFit(); 


        }

        #endregion

        //#region Set Style Methods
        ///// <summary>
        ///// Ԫ񱳾ɫ䷽ʽ
        ///// </summary>
        ///// <param name="startRow">ʼ</param>
        ///// <param name="startColumn">ʼ</param>
        ///// <param name="endRow"></param>
        ///// <param name="endColumn"></param>
        ///// <param name="color">ɫ</param>
        //public void CellsBackColor(int startRow, int startColumn, int endRow, int endColumn, ColorIndex color) 

        //{
        //    Excel.Range range = myExcel.get_Range(myExcel.Cells[startRow, startColumn], myExcel.Cells[endRow, endColumn]);
        //    range.Interior.ColorIndex = color;
        //    range.Interior.Pattern = Pattern.Solid;
        //}
        ///// <summary>
        ///// Ԫ񱳾ɫ䷽ʽ
        ///// </summary>
        ///// <param name="startRow">ʼ</param>
        ///// <param name="startColumn">ʼ</param>
        ///// <param name="endRow"></param> 


        ///// <param name="endColumn"></param>
        ///// <param name="color">ɫ</param>
        ///// <param name="pattern">䷽ʽ</param>
        //public void CellsBackColor(int startRow, int startColumn, int endRow, int endColumn, ColorIndex color, Pattern pattern)
        //{
        //    Excel.Range range = myExcel.get_Range(myExcel.Cells[startRow, startColumn], myExcel.Cells[endRow, endColumn]);
        //    range.Interior.ColorIndex = color;
        //    range.Interior.Pattern = pattern;
        //}
        ///// <summary> 

        ///// и
        ///// </summary>
        ///// <param name="startRow">ʼ</param>
        ///// <param name="endRow"></param>
        ///// <param name="height">и</param>
        //public void SetRowHeight(int startRow, int endRow, int height)
        //{
        //    //ȡǰʹõĹ
        //    Excel.Worksheet worksheet = (Excel.Worksheet)myExcel.ActiveSheet;
        //    Excel.Range range = (Excel.Range)worksheet.Rows[startRow.ToString() + ":" + endRow.ToString(), System.Type.Missing]; 
        //    range.RowHeight = height;
        //}

        ///// <summary>
        ///// Զи
        ///// </summary>
        ///// <param name="columnNum">к</param>
        //public void RowAutoFit(int rowNum)
        //{
        //    //ȡǰʹõĹ
        //    Excel.Worksheet worksheet = (Excel.Worksheet)myExcel.ActiveSheet;
        //    Excel.Range range = (Excel.Range)worksheet.Rows[rowNum.ToString() + ":" + rowNum.ToString(), System.Type.Missing]; 
        //    range.EntireColumn.AutoFit();

        //}

        ///// <summary>
        ///// п
        ///// </summary>
        ///// <param name="startColumn">ʼ(жӦĸ)</param>
        ///// <param name="endColumn">(жӦĸ)</param>
        ///// <param name="width"></param>
        //public void SetColumnWidth(string startColumn, string endColumn, int width)
        //{
        //    //ȡǰʹõĹ
        //    Excel.Worksheet worksheet = (Excel.Worksheet)myExcel.ActiveSheet; 


        //    Excel.Range range = (Excel.Range)worksheet.Columns[startColumn + ":" + endColumn, System.Type.Missing];
        //    range.ColumnWidth = width;
        //}

        ///// <summary>
        ///// п
        ///// </summary>
        ///// <param name="startColumn">ʼ</param>
        ///// <param name="endColumn"></param>
        ///// <param name="width"></param>
        //public void SetColumnWidth(int startColumn, int endColumn, int width)
        //{ 

        //    string strStartColumn = GetColumnName(startColumn);
        //    string strEndColumn = GetColumnName(endColumn);
        //    //ȡǰʹõĹ
        //    Excel.Worksheet worksheet = (Excel.Worksheet)myExcel.ActiveSheet;
        //    Excel.Range range = (Excel.Range)worksheet.Columns[strStartColumn + ":" + strEndColumn, System.Type.Missing];
        //    range.ColumnWidth = width;
        //}

        ///// <summary>
        ///// Զп
        ///// </summary> http://www.mscto.com 
        ///// <param name="columnNum">к</param>
        //public void ColumnAutoFit(string column)
        //{
        //    //ȡǰʹõĹ
        //    Excel.Worksheet worksheet = (Excel.Worksheet)myExcel.ActiveSheet;
        //    Excel.Range range = (Excel.Range)worksheet.Columns[column + ":" + column, System.Type.Missing];
        //    range.EntireColumn.AutoFit();

        //}

        ///// <summary>
        ///// Զп
        ///// </summary> 
        ///// <param name="columnNum">к</param>
        //public void ColumnAutoFit(int columnNum)
        //{
        //    string strcolumnNum = GetColumnName(columnNum);
        //    //ȡǰʹõĹ
        //    Excel.Worksheet worksheet = (Excel.Worksheet)myExcel.ActiveSheet;
        //    Excel.Range range = (Excel.Range)worksheet.Columns[strcolumnNum + ":" + strcolumnNum, System.Type.Missing];
        //    range.EntireColumn.AutoFit();

        //}


        ///// <summary> 
        ///// ɫ
        ///// </summary>
        ///// <param name="startRow">ʼ</param>
        ///// <param name="startColumn">ʼ</param>
        ///// <param name="endRow"></param>
        ///// <param name="endColumn"></param>
        ///// <param name="color">ɫ</param>
        //public void FontColor(int startRow, int startColumn, int endRow, int endColumn, ColorIndex color)
        //{
        //    Excel.Range range = myExcel.get_Range(myExcel.Cells[startRow, startColumn], myExcel.Cells[endRow, endColumn]); 
        //    range.Font.ColorIndex = color;
        //}

        ///// <summary>
        ///// ʽ(Ӵ,б,»)
        ///// </summary>
        ///// <param name="startRow">ʼ</param>
        ///// <param name="startColumn">ʼ</param>
        ///// <param name="endRow"></param>
        ///// <param name="endColumn"></param>
        ///// <param name="isBold">ǷӴ</param>
        ///// <param name="isItalic">Ƿб</param> 
        ///// <param name="underline">»</param>
        //public void FontStyle(int startRow, int startColumn, int endRow, int endColumn, bool isBold, bool isItalic, UnderlineStyle underline)
        //{
        //    Excel.Range range = myExcel.get_Range(myExcel.Cells[startRow, startColumn], myExcel.Cells[endRow, endColumn]);
        //    range.Font.Bold = isBold;
        //    range.Font.Underline = underline;
        //    range.Font.Italic = isItalic;
        //}

        ///// <summary>
        ///// Ԫ弰С 


        ///// </summary>
        ///// <param name="startRow">ʼ</param>
        ///// <param name="startColumn">ʼ</param>
        ///// <param name="endRow"></param>
        ///// <param name="endColumn"></param>
        ///// <param name="fontName"></param>
        ///// <param name="fontSize">С</param>
        //public void FontNameSize(int startRow, int startColumn, int endRow, int endColumn, string fontName, int fontSize)
        //{
        //    Excel.Range range = myExcel.get_Range(myExcel.Cells[startRow, startColumn], myExcel.Cells[endRow, endColumn]); 


        //    range.Font.Name = fontName;
        //    range.Font.Size = fontSize;
        //}


        //#endregion

        #region ExcelHelper Kit
        /// <summary>
        /// Excelеĸֵתֵ
        /// </summary>
        /// <param name="letter"></param>
        /// <returns></returns>
        public int LetterToInt(string letter)
        {
            int n = 0; 


            if (letter.Trim().Length == 0)
                throw new Exception("ַܿ");

            if (letter.Length >= 2)
            {
                char c1 = letter.ToCharArray(0, 2)[0];
                char c2 = letter.ToCharArray(0, 2)[1];

                if (!char.IsLetter(c1) || !char.IsLetter(c2))
                {
                    throw new Exception("ʽȷĸ"); 
                }

                c1 = char.ToUpper(c1);
                c2 = char.ToUpper(c2);

                int i = Convert.ToInt32(c1) - 64;
                int j = Convert.ToInt32(c2) - 64;

                n = i * 26 + j;
            }

            if (letter.Length == 1)
            {
                char c1 = letter.ToCharArray()[0]; 


                if (!char.IsLetter(c1))
                {
                    throw new Exception("ʽȷĸ");
                }

                c1 = char.ToUpper(c1);

                n = Convert.ToInt32(c1) - 64;
            }

            if (n > 256)
                throw new Exception("ΧExcelܳ256"); 

            return n;
        }

        /// <summary>
        /// ExcelеֵתΪֵַ
        /// </summary>
        /// <param name="n"></param>
        /// <returns></returns>
        public string IntToLetter(int n)
        {
            if (n > 256)
                throw new Exception("ΧExcelܳ256");

            int i = Convert.ToInt32(n / 26); 
            int j = n % 26;

            char c1 = Convert.ToChar(i + 64);
            char c2 = Convert.ToChar(j + 64);

            if (n > 26)
                return c1.ToString() + c2.ToString();
            else if (n == 26)
                return "Z";
            else
                return c2.ToString();
        }

        #endregion 


        #region Output File(ע⣺ĿļѴڵĻ)
        /// <summary>
        /// Excelļ˳
        /// </summary>
        public void OutputExcelFile()
        {
            if (this.outputFile == null)
                throw new Exception("ûָļ·");

            try
            {
                workBook.SaveAs(outputFile, missing, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing); 

            }
            catch (Exception e)
            {
                throw e;
            }
            finally
            {
                this.Dispose();
            }
        }

        /// <summary>
        /// ָʽļָ֧ʽHTMLCSVTEXTEXCEL
        /// </summary> 

        /// <param name="format">HTMLCSVTEXTEXCELXML</param>
        public void OutputFile(string format)
        {
            if (this.outputFile == null)
                throw new Exception("ûָļ·");

            try
            {
                switch (format)
                {
                    case "HTML": 

                        {
                            workBook.SaveAs(outputFile, Excel.XlFileFormat.xlHtml, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
                            break;
                        }
                    case "CSV":
                        { 
                            workBook.SaveAs(outputFile, Excel.XlFileFormat.xlCSV, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
                            break;
                        }
                    case "TEXT":
                        {
                            workBook.SaveAs(outputFile, Excel.XlFileFormat.xlHtml, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing); 


                            break;
                        }
                    //     case "XML":
                    //     {
                    //      workBook.SaveAs(outputFile,Excel.XlFileFormat.xlXMLSpreadsheet, Type.Missing, Type.Missing,
                    //       Type.Missing, Type.Missing, Excel.XlSaveAsAccessMode.xlNoChange, 

                    //       Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing);
                    //      break;
                    //
                    //     }
                    default:
                        {
                            workBook.SaveAs(outputFile, missing, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing); 
                            break;
                        }
                }
            }
            catch (Exception e)
            {
                throw e;
            }
            finally
            {
                this.Dispose(); 
            }
        }

        /// <summary>
        /// ļ
        /// </summary>
        public void SaveFile()
        {
            try
            {
                workBook.Save();
            }
            catch (Exception e)
            {
                throw e; 
            }
            finally
            {
                this.Dispose();
            }
        }

        /// <summary>
        /// ļ
        /// </summary>
        public void SaveAsFile()
        {
            if (this.outputFile == null)
                throw new Exception("ûָļ·"); 

            try
            {
                workBook.SaveAs(outputFile, missing, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
            }
            catch (Exception e)
            {
                throw e;
            }
            finally
            {
                this.Dispose(); 


            }
        }

        /// <summary>
        /// ExcelļΪָʽ
        /// </summary>
        /// <param name="format">HTMLCSVTEXTEXCELXML</param>
        public void SaveAsFile(string format)
        {
            if (this.outputFile == null)
                throw new Exception("ûָļ·");

            try
            {
                switch (format) 
                {
                    case "HTML":
                        {
                            workBook.SaveAs(outputFile, Excel.XlFileFormat.xlHtml, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
                            break;
                        } 
                    case "CSV":
                        {
                            workBook.SaveAs(outputFile, Excel.XlFileFormat.xlCSV, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
                            break;
                        }
                    case "TEXT": 


                        {
                            workBook.SaveAs(outputFile, Excel.XlFileFormat.xlHtml, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
                            break;
                        }
                    //     case "XML":
                    //     { 

                    //      workBook.SaveAs(outputFile,Excel.XlFileFormat.xlXMLSpreadsheet, Type.Missing, Type.Missing,
                    //       Type.Missing, Type.Missing, Excel.XlSaveAsAccessMode.xlNoChange,
                    //       Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing);
                    //      break;
                    //     }
                    default:  
                        {
                            workBook.SaveAs(outputFile, missing, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
                            break;
                        }
                }
            }
            catch (Exception e) 

            {
                throw e;
            }
            finally
            {
                this.Dispose();
            }
        }

        /// <summary>
        /// ļ
        /// </summary>
        /// <param name="fileName">ļ</param>
        public void SaveFile(string fileName) 
        {
            try
            {
                workBook.SaveAs(fileName, missing, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
            }
            catch (Exception e)
            {
                throw e;
            }
            finally
            {
                this.Dispose(); 


            }
        }

        /// <summary>
        /// ExcelļΪָʽ
        /// </summary>
        /// <param name="fileName">ļ</param>
        /// <param name="format">HTMLCSVTEXTEXCELXML</param>
        public void SaveAsFile(string fileName, string format)
        {
            try
            {
                switch (format)
                { 
                    case "HTML":
                        {
                            workBook.SaveAs(fileName, Excel.XlFileFormat.xlHtml, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
                            break;
                        }
                    case "CSV": 
                        {
                            workBook.SaveAs(fileName, Excel.XlFileFormat.xlCSV, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
                            break;
                        }
                    case "TEXT":
                        { 
                            workBook.SaveAs(fileName, Excel.XlFileFormat.xlHtml, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
                            break;
                        }
                    //     case "XML":
                    //     {
                    //      workBook.SaveAs(fileName,Excel.XlFileFormat.xlXMLSpreadsheet, Type.Missing, Type.Missing, 

                    //       Type.Missing, Type.Missing, Excel.XlSaveAsAccessMode.xlNoChange,
                    //       Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing);
                    //      break;
                    //     }
                    default:
                        { 
                            workBook.SaveAs(fileName, missing, missing, missing, missing, missing, Excel.XlSaveAsAccessMode.xlExclusive, missing, missing, missing, missing, missing);
                            break;
                        }
                }
            }
            catch (Exception e)
            {
                throw e; 
            }
            finally
            {
                this.Dispose();
            }
        }
        #endregion

        #endregion

   #region ˽з

        /// <summary>
        /// ϲԪ񣬲ֵָWorkSheet
        /// </summary>
        /// <param name="beginRowIndex">ʼ</param>
        /// <param name="beginColumnIndex">ʼ</param> 
        /// <param name="endRowIndex"></param>
        /// <param name="endColumnIndex"></param>
        /// <param name="text">ϲRangeֵ</param>
        private void MergeCells(Excel.Worksheet sheet, int beginRowIndex, int beginColumnIndex, int endRowIndex, int endColumnIndex, string text)
        {
            if (sheet == null)
                return;

            range = sheet.get_Range(sheet.Cells[beginRowIndex, beginColumnIndex], sheet.Cells[endRowIndex, endColumnIndex]);

            range.ClearContents(); //ȰRangeϲŲ http://www.mscto.com 
            range.MergeCells = true;
            range.Value2 = text;
            range.HorizontalAlignment = Excel.XlHAlign.xlHAlignCenter;
            range.VerticalAlignment = Excel.XlVAlign.xlVAlignCenter;
        }

        /// <summary>
        /// ָеͬкϲָWorkSheet
        /// </summary>
        /// <param name="columnIndex">Ҫϲ</param>
        /// <param name="beginRowIndex">ϲʼ</param>
        /// <param name="rows">Ҫϲ</param> 
        private void MergeRows(Excel.Worksheet sheet, int columnIndex, int beginRowIndex, int rows)
        {
            int beginIndex = beginRowIndex;
            int count = 0;
            string text1;
            string text2;

            if (sheet == null)
                return;

            for (int j = beginRowIndex; j < beginRowIndex + rows; j++)
            {
                range1 = (Excel.Range)sheet.Cells[j, columnIndex]; 
                range2 = (Excel.Range)sheet.Cells[j + 1, columnIndex];
                text1 = range1.Text.ToString();
                text2 = range2.Text.ToString();

                if (text1 == text2)
                {
                    ++count;
                }
                else
                {  
                    if (count > 0)
                    {
                        this.MergeCells(sheet, beginIndex, columnIndex, beginIndex + count, columnIndex, text1);
                    }

                    beginIndex = j + 1; //ÿʼϲ
                    count = 0; //0
                }


            }

        }


        /// <summary>
        /// WorkSheet
        /// </summary>
        /// <param name="rowCount">¼</param>
        /// <param name="rows">ÿWorkSheet</param>
        public int GetSheetCount(int rowCount, int rows)
        {
            int n = rowCount % rows; //

            if (n == 0)
                return rowCount / rows; 


            else
                return Convert.ToInt32(rowCount / rows) + 1;
        }


        /// <summary>
        /// Excel
        /// </summary>
        public void KillExcelProcess()
        {
            Process[] myProcesses;
            DateTime startTime;
            myProcesses = Process.GetProcessesByName("Excel");

            //òExcelIDʱֻжϽʱ 
            foreach (Process myProcess in myProcesses)
            {
                startTime = myProcess.StartTime;

                if (startTime > beforeTime && startTime < afterTime)
                {
                    myProcess.Kill();
                }
            }
        }


        private void Dispose() 
        {
            workBook.Close(null, null, null);
            app.Workbooks.Close();
            app.Quit();

            if (range != null)
            {
                System.Runtime.InteropServices.Marshal.ReleaseComObject(range);
                range = null;
            }
            if (range1 != null)
            {
                System.Runtime.InteropServices.Marshal.ReleaseComObject(range1); 
                range1 = null;
            }
            if (range2 != null)
            {
                System.Runtime.InteropServices.Marshal.ReleaseComObject(range2);
                range2 = null;
            }
            if (textBox != null)
            {
                System.Runtime.InteropServices.Marshal.ReleaseComObject(textBox);  
                textBox = null;
            }
            if (workSheet != null)
            {
                System.Runtime.InteropServices.Marshal.ReleaseComObject(workSheet);
                workSheet = null;
            }
            if (workBook != null)
            {
                System.Runtime.InteropServices.Marshal.ReleaseComObject(workBook); 

                workBook = null;
            }
            if (app != null)
            {
                System.Runtime.InteropServices.Marshal.ReleaseComObject(app);
                app = null;
            }

            GC.Collect();

            this.KillExcelProcess();

        }//end Dispose
        #endregion

    }
}
